IF EXISTS(SELECT name FROM sysobjects
           WHERE name = 'RECALC_FATCORR_PROD_REC' AND type = 'P')
DROP PROCEDURE RECALC_FATCORR_PROD_REC
GO

CREATE PROCEDURE RECALC_FATCORR_PROD_REC
 @P_PRATOINI     VARCHAR,
 @P_PRATOFIN     VARCHAR,
 @P_CDFILAUXPRAT VARCHAR, -- FILIAL PARA CARREGAR PRATO LOCAL
 @P_CDFILIAIS    VARCHAR, -- X: NO CONSIDERAR RECEITA LOCAL T: CONSIDERA CDFILIAL_
 @P_SERVICOS     VARCHAR, -- X: NO CONSIDERAR RECEITA POR SERVIO T: CONSIDERA CDFILIAL||CDSERVFILI_
 @P_NRORG        VARCHAR
AS
  DECLARE @V_QTBLOQUEADA   VARCHAR(1);
  DECLARE @V_NOVO_QTBRUTA  DOUBLE PRECISION;
  DECLARE @V_NOVO_QTLIQ    DOUBLE PRECISION;
  DECLARE @V_NOVA_QTREQ    DOUBLE PRECISION;
  DECLARE @V_NOVO_CALCNUTR DOUBLE PRECISION;
  DECLARE @V_FATOR         DOUBLE PRECISION;
  DECLARE @V_QTD           DOUBLE PRECISION;
  
  -- VARIVEIS PARA O CURSOR
  DECLARE @C_QTBRUTA       DOUBLE PRECISION;
  DECLARE @C_FATOCORR      DOUBLE PRECISION;
  DECLARE @C_GANHOCOC      DOUBLE PRECISION;
  DECLARE @C_VRFATOCONVES  DOUBLE PRECISION;
  DECLARE @C_APROVNUTR     DOUBLE PRECISION;
  DECLARE @C_QTLIQ         DOUBLE PRECISION;
  DECLARE @C_QTREQ         DOUBLE PRECISION;
  DECLARE @C_CDSERVFILI    VARCHAR(5);
  DECLARE @C_CDFILIAL      VARCHAR(4);
  DECLARE @C_CDPRODUTO     VARCHAR(10);
  DECLARE @C_CDPRATO       VARCHAR(10);
  DECLARE @C_CDFILAUXPRAT  VARCHAR(4);
  DECLARE @C_NRORG         INTEGER;

BEGIN  

 --VERIFICAR QUAL QUANTIDADE EST ATIVA
  SELECT @V_QTBLOQUEADA = IDQTLIQUBRUT
    FROM PARAMPLANEJA 
   WHERE CDFILIAL = @P_CDFILAUXPRAT 
     AND NRORG    = @P_NRORG;
  
  IF ((@V_QTBLOQUEADA IS NULL) OR (@V_QTBLOQUEADA = '')) BEGIN
    SET @V_QTBLOQUEADA = 'L';
  END;

  DECLARE C_REC CURSOR FOR
  SELECT RECEITA.QTBRUTA, ROUND(PRODUTO.VRPEFATOCORR, 3) AS FATOCORR, RECEITA.GANHOCOC, ISNULL(CONVPRODUTO.VRFATOCONVES, 1) AS VRFATOCONVES,
         RECEITA.QTLIQ, RECEITA.QTREQ, RECEITA.CDFILIAL, RECEITA.CDSERVFILI, RECEITA.CDPRATO, RECEITA.CDFILAUXPRAT, 
         RECEITA.CDPRODUTO, RECEITA.APROVNUTR,         
         CASE WHEN RECEITA.SGUNIDADE IS NULL THEN PRODUTO.SGUNIDADE ELSE RECEITA.SGUNIDADE END AS SGUNIDADE,         
         RECEITA.QTUNI, RECEITA.PERDALIMP, RECEITA.CALCNUTR,
         ISNULL(RECEITA.QTFIXEM, 'N') AS QTFIXEM, RECEITA.NRORG
  FROM (SELECT '' AS CDFILIAL, '' AS CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPRODUTO, SGUNIDADE, QTPRODPRAT AS QTLIQ, 
               VRPEFATCOCPR AS GANHOCOC, VRPEFATCORPR AS PERDALIMP, QTUNIDESTPR AS QTUNI, QTBRUTAPR AS QTREQ, 
               VRPEFATNUTPR AS APROVNUTR, QTCALCNUTRPR AS CALCNUTR, QTBRUTAPRUNR AS QTBRUTA, IDQTDEFIXPR AS QTFIXEM, NRORG
          FROM RECEPADR
         WHERE (CDFILAUXPRAT = 'P' OR CDFILAUXPRAT = @P_CDFILAUXPRAT)
           AND (CDPRATO BETWEEN @P_PRATOINI AND @P_PRATOFIN)
           AND (NRORG = @P_NRORG)
         UNION ALL
        SELECT CDFILIAL, '' AS CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPRODUTO, SGUNIDADE, QTPRODRECLOC AS QTLIQ, 
               VRPEFATCOCLO AS GANHOCOC, VRPEFATCORLO AS PERDALIMP, QTUNIDESTLO AS QTUNI, QTBRUTALO AS QTREQ, 
               VRPEFATNUTLO AS APROVNUTR, QTCALCNUTRLO AS CALCNUTR, QTBRUTALOUNR AS QTBRUTA, IDQTDEFIXLO AS QTFIXEM, NRORG
          FROM RECEFILI
         WHERE (CDFILAUXPRAT = 'P' OR CDFILAUXPRAT = @P_CDFILAUXPRAT)
           AND (CDPRATO BETWEEN @P_PRATOINI AND @P_PRATOFIN)
           AND (NRORG = @P_NRORG)
           AND (CHARINDEX(CDFILIAL, @P_CDFILIAIS) > 0 OR @P_CDFILIAIS = 'T')
         UNION ALL
        SELECT CDFILIAL, CDSERVFILI, CDPRATO, CDFILAUXPRAT, CDPRODUTO, SGUNIDADE, QTPRODRECSER AS QTLIQ, 
               VRPEFATCOCSE AS GANHOCOC, VRPEFATCORSE AS PERDALIMP, QTUNIDESTSE AS QTUNI, QTBRUTASE AS QTREQ, 
               VRPEFATNUTSE AS APROVNUTR, QTCALCNUTRSE AS CALCNUTR, QTBRUTASEUNR AS QTBRUTA, IDQTDEFIXSE AS QTFIXEM, NRORG
          FROM RECESERV
         WHERE (CDFILAUXPRAT = 'P' OR CDFILAUXPRAT = @P_CDFILAUXPRAT)
           AND (CDPRATO BETWEEN @P_PRATOINI AND @P_PRATOFIN)
           AND (NRORG = @P_NRORG)
           AND (CHARINDEX(CDFILIAL, @P_CDFILIAIS) > 0 OR @P_CDFILIAIS = 'T')
           AND (CHARINDEX(CDFILIAL+CDSERVFILI, @P_SERVICOS) > 0 OR @P_SERVICOS = 'T')
       ) RECEITA
 INNER JOIN PRODUTO ON PRODUTO.CDPRODUTO = RECEITA.CDPRODUTO AND PRODUTO.NRORG = RECEITA.NRORG AND VRPEFATOCORR > 0
  LEFT JOIN CONVPRODUTO ON CONVPRODUTO.NRORG = PRODUTO.NRORG AND CONVPRODUTO.CDPRODUTO = RECEITA.CDPRODUTO AND CONVPRODUTO.SGUNIDADE = RECEITA.SGUNIDADE
 ORDER BY RECEITA.CDPRATO, RECEITA.CDFILAUXPRAT, RECEITA.CDFILIAL, RECEITA.CDSERVFILI, RECEITA.CDPRODUTO;
 OPEN C_REC;
 FETCH NEXT FROM C_REC INTO @C_QTBRUTA, @C_FATOCORR, @C_GANHOCOC, @C_VRFATOCONVES, @C_APROVNUTR, @C_QTLIQ, @C_QTREQ, @C_CDFILIAL, @C_CDSERVFILI;

  WHILE (@@FETCH_STATUS = 0) BEGIN
      -- CALCULA A QUANTIDADE DE ACORDO COM O PARAMETRO
      IF (@V_QTBLOQUEADA = 'L') BEGIN
          SET @V_NOVO_QTBRUTA = @C_QTBRUTA;

          SET @V_QTD = @C_QTBRUTA - ((@C_QTBRUTA * @C_FATOCORR) / 100);
          SET @V_NOVO_QTLIQ = ROUND(@V_QTD + ((@V_QTD * @C_GANHOCOC) / 100), 5);

          SET @V_NOVA_QTREQ = @V_NOVO_QTBRUTA * @C_VRFATOCONVES;

          SET @V_NOVO_CALCNUTR = (@V_NOVO_QTLIQ * @C_VRFATOCONVES) * @C_APROVNUTR / 100;
      END
      ELSE BEGIN
          SET @V_NOVO_QTLIQ = @C_QTLIQ;

          SET @V_QTD = (@C_QTLIQ / (@C_GANHOCOC + 100)) * 100;
          SET @V_NOVO_QTBRUTA = ROUND((@V_QTD / (100 - @C_FATOCORR)) * 100, 5);

          IF (@C_FATOCORR > 0) BEGIN
              SET @V_FATOR = @C_VRFATOCONVES;
              SET @V_NOVO_CALCNUTR = (@V_NOVO_QTLIQ * @C_APROVNUTR / 100) * @V_FATOR;
          END
          ELSE BEGIN
              SET @V_FATOR = @C_QTREQ / @C_QTBRUTA;        
              SET @V_NOVO_CALCNUTR = (@V_NOVO_QTLIQ * @C_APROVNUTR / 100);
          END;

          SET @V_NOVA_QTREQ = @V_NOVO_QTBRUTA * @V_FATOR;
      END;

      IF (@C_CDSERVFILI IS NOT NULL) BEGIN
          UPDATE RECESERV
             SET VRPEFATCORSE = @C_FATOCORR,
                 QTPRODRECSER = @V_NOVO_QTLIQ,
                 QTBRUTASEUNR = @V_NOVO_QTBRUTA,
                 QTCALCNUTRSE = @V_NOVO_CALCNUTR,
                 QTBRUTASE    = @V_NOVA_QTREQ,
                 QTUNIDESTSE  = @V_NOVA_QTREQ
           WHERE CDPRODUTO    = @C_CDPRODUTO
             AND CDFILIAL     = @C_CDFILIAL
             AND CDSERVFILI   = @C_CDSERVFILI
             AND CDPRATO      = @C_CDPRATO
             AND CDFILAUXPRAT = @C_CDFILAUXPRAT
             AND NRORG        = @C_NRORG;           
      END
      ELSE BEGIN
          IF (@C_CDFILIAL IS NOT NULL) BEGIN
              UPDATE RECEFILI
                 SET VRPEFATCORLO = @C_FATOCORR,
                     QTPRODRECLOC = @V_NOVO_QTLIQ,
                     QTBRUTALOUNR = @V_NOVO_QTBRUTA,
                     QTCALCNUTRLO = @V_NOVO_CALCNUTR,
                     QTBRUTALO    = @V_NOVA_QTREQ,
                     QTUNIDESTLO  = @V_NOVA_QTREQ
               WHERE CDPRODUTO    = @C_CDPRODUTO
                AND CDFILIAL      = @C_CDFILIAL
                AND CDPRATO       = @C_CDPRATO
                AND CDFILAUXPRAT  = @C_CDFILAUXPRAT
                AND NRORG         = @C_NRORG;
          END
          ELSE BEGIN
              UPDATE RECEPADR
                 SET VRPEFATCORPR = @C_FATOCORR,
                     QTPRODPRAT   = @V_NOVO_QTLIQ,
                     QTBRUTAPRUNR = @V_NOVO_QTBRUTA,
                     QTCALCNUTRPR = @V_NOVO_CALCNUTR,
                     QTBRUTAPR    = @V_NOVA_QTREQ,
                     QTUNIDESTPR  = @V_NOVA_QTREQ
               WHERE CDPRODUTO    = @C_CDPRODUTO
                 AND CDPRATO      = @C_CDPRATO
                 AND CDFILAUXPRAT = @C_CDFILAUXPRAT
                 AND NRORG        = @C_NRORG;        
          END;
      END;
      SET @V_NOVO_QTLIQ    = 0;
      SET @V_QTD           = 0;
      SET @V_NOVO_QTBRUTA  = 0;
      SET @V_FATOR         = 0;
      SET @V_NOVA_QTREQ    = 0;
      SET @V_NOVO_CALCNUTR = 0;    
      FETCH NEXT FROM C_REC INTO @C_QTBRUTA, @C_FATOCORR, @C_GANHOCOC, @C_VRFATOCONVES, @C_APROVNUTR, @C_QTLIQ, @C_QTREQ, @C_CDFILIAL, @C_CDSERVFILI;
  END;
  CLOSE C_COMPPADRAO;
  DEALLOCATE C_COMPPADRAO; 
  COMMIT;
END;
GO
